# Fancy waifu motd

WAIFUS=52                             # count of waifus
RESOLUTION=128                        # resolution of waifu
CACHEFILE="$HOME/.cache/waifu"        # to cache waifu state
MINTERMWIDTH=200                      # minimal width of term, to display motd
CENTER=true                           # center motd?
LOLCAT=false                          # use lolcat?
UNAMEARG="-sr"                        # uname arguments
UPTIMEARG="--pretty"                  # uptime arguments

output() {
  val=0
  if [ $1 == "true" ]; then val=$(($val + 1)); fi
  if [ $2 == "true" ]; then val=$(($val + 2)); fi
  if [ -f "/usr/games/lolcat" ]; then lx="/usr/games/lolcat"; else lx="/usr/bin/lolcat"; fi
  case "$val" in
    0)
      /bin/cat /usr/share/motd/motd 
      uname $UNAMEARG 
      uptime $UPTIMEARG
      ;;

    1)
      /bin/cat /usr/share/motd/motd | $lx
      uname $UNAMEARG | $lx
      uptime $UPTIMEARG | $lx
      ;;

    2)
      /bin/cat /usr/share/motd/motd | awk '{ z = '$(tput cols)' - length; y = int(z / 2); x = z - y; printf "%*s%s%*s\n", x, "", $0, y, ""; }'
      uname $UNAMEARG | awk '{ z = '$(tput cols)' - length; y = int(z / 2); x = z - y; printf "%*s%s%*s\n", x, "", $0, y, ""; }'
      uptime $UPTIMEARG | awk '{ z = '$(tput cols)' - length; y = int(z / 2); x = z - y; printf "%*s%s%*s\n", x, "", $0, y, ""; }'
      ;;

    3)
      /bin/cat /usr/share/motd/motd | awk '{ z = '$(tput cols)' - length; y = int(z / 2); x = z - y; printf "%*s%s%*s\n", x, "", $0, y, ""; }' | $lx
      uname $UNAMEARG | awk '{ z = '$(tput cols)' - length; y = int(z / 2); x = z - y; printf "%*s%s%*s\n", x, "", $0, y, ""; }' | $lx
      uptime $UPTIMEARG | awk '{ z = '$(tput cols)' - length; y = int(z / 2); x = z - y; printf "%*s%s%*s\n", x, "", $0, y, ""; }' | $lx
      ;;
  esac
}


if [ $(tput cols) -gt $MINTERMWIDTH ]
then
  if [ $TERM == "xterm-kitty" ]
  then
    if [ $((0 + RANDOM % 2)) -eq 0 ]
    then
      if [ -f "$CACHEFILE" ]
      then
        WAIFU=$(/bin/cat $CACHEFILE)
      else
        touch $CACHEFILE
        echo 0 > $CACHEFILE
        WAIFU=$((0 + RANDOM % $WAIFUS))
      fi
      if [ $WAIFU -gt $WAIFUS ]
      then
        echo 0 > $CACHEFILE
        WAIFU=$((0 + RANDOM % $WAIFUS))
      else
        echo $(($WAIFU + 1)) > $CACHEFILE
      fi
      if $CENTER; then kitty +kitten icat "/usr/share/motd/waifus/waifu-$WAIFU.$RESOLUTION.png"; else kitty +kitten icat --align left "/usr/share/motd/waifus/waifu-$WAIFU.$RESOLUTION.png"; fi
    else
      if $CENTER; then kitty +kitten icat "/usr/share/motd/waifus/waifu-$((0 + RANDOM % $WAIFUS)).$RESOLUTION.png"; else kitty +kitten icat --align left "/usr/share/motd/waifus/waifu-$((0 + RANDOM % $WAIFUS)).$RESOLUTION.png"; fi
    fi
  fi
  output $LOLCAT $CENTER
fi


